; Driveur symbolique en LISP
; Est capable de driv des truc style:
; (* (+ x y) 5)
; Valvassori Mose - 1999

(de operateur (x)
    (if (atom x)
	nil
      (car x)))
(de premier-operande (x)
    (cadr x))
(de second-operande (x)
    (caddr x))


(de derive (list var)
    (cond 
     ((eq (operateur list) nil)
      (derive-atom list var))
     ((eq (operateur list) '+)
	(derive-add list var))
     ((eq (operateur list) '*)
	(derive-mul list var))
      ))


(de derive-addition (list var)
    (list '+ (derive (premier-operande list) var)
	  (derive (second-operande list) var))
    )

(de derive-mul (list var)
    (list '+ 
	  (list '* (derive (premier-operande list) var)
		(second-operande list))
	  (list '* (derive (second-operande list) var)
		(premier-operande list))
	  ))	  

(de derive-atom (atom var)
    (if (eq atom var)
	1
      0
      ))
